<?php
/************************************************************************
 * MXChange v0.2.1                                    Start: 08/31/2003 *
 * ===============                              Last change: 11/23/2004 *
 *                                                                      *
 * -------------------------------------------------------------------- *
 * File              : admin-inc.php                                    *
 * -------------------------------------------------------------------- *
 * Short description : Administrative related functions                 *
 * -------------------------------------------------------------------- *
 * Kurzbeschreibung  : Fuer die Administration benoetigte Funktionen    *
 * -------------------------------------------------------------------- *
 *                                                                      *
 * -------------------------------------------------------------------- *
 * Copyright (c) 2003 - 2008 by Roland Haeder                           *
 * For more information visit: http://www.mxchange.org                  *
 *                                                                      *
 * This program is free software; you can redistribute it and/or modify *
 * it under the terms of the GNU General Public License as published by *
 * the Free Software Foundation; either version 2 of the License, or    *
 * (at your option) any later version.                                  *
 *                                                                      *
 * This program is distributed in the hope that it will be useful,      *
 * but WITHOUT ANY WARRANTY; without even the implied warranty of       *
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the        *
 * GNU General Public License for more details.                         *
 *                                                                      *
 * You should have received a copy of the GNU General Public License    *
 * along with this program; if not, write to the Free Software          *
 * Foundation, Inc., 51 Franklin St, Fifth Floor, Boston,               *
 * MA  02110-1301  USA                                                  *
 ************************************************************************/

// Some security stuff...
if (!defined('__SECURITY')) {
	$INC = substr(dirname(__FILE__), 0, strpos(dirname(__FILE__), "/inc") + 4) . "/security.php";
	require($INC);
}

//
function REGISTER_ADMIN ($user, $md5, $email=WEBMASTER)
{
	$ret = "failed";
	$result = SQL_QUERY_ESC("SELECT id FROM "._MYSQL_PREFIX."_admins WHERE login='%s' LIMIT 1",
	 array($user), __FILE__, __LINE__);
	if (SQL_NUMROWS($result) == 0) {
		// Ok, let's create the admin login
		$result = SQL_QUERY_ESC("INSERT INTO "._MYSQL_PREFIX."_admins (login, password, email) VALUES('%s', '%s', '%s')",
		 array($user, $md5, $email), __FILE__, __LINE__);
		$ret = "done";
	} else {
		// Free memory
		SQL_FREERESULT($result);

		// Login does already exist
		$ret = "already";
	}
	return $ret;
}
// Only be executed on login procedure!
function CHECK_ADMIN_LOGIN ($admin_login, $password)
{
	global $cacheArray, $_CONFIG, $cacheInstance;

	// Init variables
	$ret = "404";
	$data = array();

	// Is the cache valid?
	if (!empty($cacheArray['admins']['password'][$admin_login])) {
		// Get password from cache
		$data['password'] = $cacheArray['admins']['password'][$admin_login];
		$ret = "pass";
		$_CONFIG['cache_hits']++;

		// Include more admins data?
		if (GET_EXT_VERSION("admins") >= "0.7.0") {
			// Load them here
			$data['login_failtures'] = $cacheArray['admins']['login_failtures'][$admin_login];
			$data['last_failture']   = $cacheArray['admins']['last_failture'][$admin_login];
		} // END - if
	} elseif (EXT_IS_ACTIVE("cache")) {
		$ADD = "";
		if (GET_EXT_VERSION("admins") >= "0.7.0") {
			// Load them here
			$ADD = ", login_failtures, UNIX_TIMESTAMP(last_failture) AS last_failture";
		} // END - if

		// Get password from DB
		$result = SQL_QUERY_ESC("SELECT password".$ADD." FROM "._MYSQL_PREFIX."_admins WHERE login='%s' LIMIT 1",
		 array($admin_login), __FILE__, __LINE__);
		if (SQL_NUMROWS($result) == 1) {
			// Login password found
			$ret = "pass";

			// Fetch data
			$data = SQL_FETCHARRAY($result);
		} // END - if

		// Free result
		SQL_FREERESULT($result);
	}

	//* DEBUG: */ echo "*".$data['password']."/".md5($password)."/".$ret."<br />";
	if ((isset($data['password'])) && (strlen($data['password']) == 32) && ($data['password'] == md5($password))) {
		// Generate new hash
		$data['password'] = generateHash($password);

		// Is the sql_patches not installed, than we cannot have a valid hashed password here!
		if (($ret == "pass") && ((EXT_VERSION_IS_OLDER("sql_patches", "0.3.6")) || (GET_EXT_VERSION("sql_patches") == ""))) $ret = "done";
	} elseif ((EXT_VERSION_IS_OLDER("sql_patches", "0.3.6")) || (GET_EXT_VERSION("sql_patches") == "")) {
		// Old hashing way
		return $ret;
	} elseif (!isset($data['password'])) {
		// Password not found, so no valid login!
		return $ret;
	}

	// Generate salt of password
	define('__SALT', substr($data['password'], 0, -40));
	$salt = __SALT;

	// Check if password is same
	//* DEBUG: */ echo "*".$ret.",".$data['password'].",".$password.",".$salt."*<br >\n";
	if (($ret == "pass") && ($data['password'] == generateHash($password, $salt)) && ((!empty($salt))) || ($data['password'] == $password)) {
		// Re-hash the plain passord with new random salt
		$data['password'] = generateHash($password);

		// Do we have 0.7.0 of admins or later?
		// Remmeber login failtures if available
		if (GET_EXT_VERSION("admins") >= "0.7.0") {
			// Store it in session
			set_session('mxchange_admin_failtures', $data['login_failtures']);
			set_session('mxchange_admin_last_fail', $data['last_failture']);

			// Update password and reset login failtures
			$result = SQL_QUERY_ESC("UPDATE "._MYSQL_PREFIX."_admins SET password='%s',login_failtures=0,last_failture='0000-00-00 00:00:00' WHERE login='%s' LIMIT 1",
				array($data['password'], $admin_login), __FILE__, __LINE__);
		} else {
			// Update password
			$result = SQL_QUERY_ESC("UPDATE "._MYSQL_PREFIX."_admins SET password='%s' WHERE login='%s' LIMIT 1",
				array($data['password'], $admin_login), __FILE__, __LINE__);
		}

		// Rebuild cache
		REBUILD_CACHE("admins", "admin");

		// Login has failed by default... ;-)
		$ret = "failed";

		// Password matches so login here
		if (LOGIN_ADMIN($admin_login, $data['password'])) {
			// All done now
			$ret = "done";
		} // END - if
	} elseif ((empty($salt)) && ($ret == "pass")) {
		// Something bad went wrong
		$ret = "failed";
	} elseif ($ret == "done") {
		// Try to login here if we have the old hashing way (sql_patches not installed?)
		if (!LOGIN_ADMIN($admin_login, $data['password'])) {
			// Something went wrong
			$ret = "failed";
		} // END - if
	}

	// Count login failture if admins extension version is 0.7.0+
	if (($ret == "pass") && (GET_EXT_VERSION("admins") >= "0.7.0")) {
		// Update counter
		SQL_QUERY_ESC("UPDATE "._MYSQL_PREFIX."_admins SET login_failtures=login_failtures+1,last_failture=NOW() WHERE login='%s' LIMIT 1",
			array($admin_login), __FILE__, __LINE__);

		// Rebuild cache
		REBUILD_CACHE("admins", "admin");
	} // END - if

	// Return the result
	//* DEBUG: */ die("RETURN=".$ret);
	return $ret;
}

// Try to login the admin by setting some session/cookie variables
function LOGIN_ADMIN ($adminLogin, $passHash) {
	global $cacheInstance;

	// Reset failture counter on matching admins version
	if ((GET_EXT_VERSION("admins") >= "0.7.0") && ((EXT_VERSION_IS_OLDER("sql_patches", "0.3.6")) || (GET_EXT_VERSION("sql_patches") == ""))) {
		// Reset counter on out-dated sql_patches version
		SQL_QUERY_ESC("UPDATE "._MYSQL_PREFIX."_admins SET login_failtures=0,last_failture='0000-00-00 00:00:00' WHERE login='%s' LIMIT 1",
			array($adminLogin), __FILE__, __LINE__);

		// Rebuild cache
		REBUILD_CACHE("admins", "admin");
	} // END - if

	// Now set all session variables and return the result
	return (
		(
			set_session("admin_md5", generatePassString($passHash))
		) && (
			set_session("admin_login", $adminLogin)
		) && (
			set_session("admin_last", time())
		) && (
			set_session("admin_to", bigintval($_POST['timeout']))
		)
	);
}

// Only be executed on cookie checking
function CHECK_ADMIN_COOKIES ($admin_login, $password) {
	global $cacheArray, $_CONFIG;
	$ret = "404"; $pass = "";

	// Get hash
	$pass = GET_ADMIN_HASH($admin_login);
	if ($pass != "-1") $ret = "pass";

	//* DEBUG: */ print __FUNCTION__."(<font color=\"#0000aa\">".__LINE__."</font>):".generatePassString($pass)."(".strlen($pass).")/".$password."(".strlen($password).")<br />\n";

	// Check if password matches
	if (($ret == "pass") && ((generatePassString($pass) == $password) || ($pass == $password) || ((strlen($pass) == 32) && (md5($password) == $pass)))) {
		// Passwords matches!
		$ret = "done";
	}

	// Return result
	return $ret;
}
//
function admin_WriteData ($file, $comment, $prefix, $suffix, $DATA, $seek=0) {
	// Initialize some variables
	$done = false;
	$seek++;
	$found = false;

	// Is the file there and read-/write-able?
	if ((FILE_READABLE($file)) && (is_writeable($file))) {
		$search = "CFG: ".$comment;
		$tmp = $file.".tmp";

		// Open the source file
		$fp = @fopen($file, 'r') or OUTPUT_HTML("<STRONG>READ:</STRONG> ".$file."<br />");

		// Is the resource valid?
		if (is_resource($fp)) {
			// Open temporary file
			$fp_tmp = @fopen($tmp, 'w') or OUTPUT_HTML("<STRONG>WRITE:</STRONG> ".$tmp."<br />");

			// Is the resource again valid?
			if (is_resource($fp_tmp)) {
				while (!feof($fp)) {
					// Read from source file
					$line = fgets ($fp, 1024);

					if (strpos($line, $search) > -1) { $next = 0; $found = true; }

					if ($next > -1) {
						if ($next == $seek) {
							$next = -1;
							$line = $prefix . $DATA . $suffix."\n";
						} else {
							$next++;
						}
					}

					// Write to temp file
					fputs($fp_tmp, $line);
				}

				// Close temp file
				fclose($fp_tmp);

				// Finished writing tmp file
				$done = true;
			}

			// Close source file
			fclose($fp);

			if (($done) && ($found)) {
				// Copy back tmp file and delete tmp :-)
				@copy($tmp, $file);
				@unlink($tmp);
				define('_FATAL', false);
			} elseif (!$found) {
				OUTPUT_HTML("<STRONG>CHANGE:</STRONG> 404!");
				define('_FATAL', true);
			} else {
				OUTPUT_HTML("<STRONG>TMP:</STRONG> UNDONE!");
				define('_FATAL', true);
			}
		}
	} else {
		// File not found, not readable or writeable
		OUTPUT_HTML("<STRONG>404:</STRONG> ".$file."<br />");
	}
}

//
function ADMIN_DO_ACTION($wht)
{
	global $menuDesription, $menuTitle, $_CONFIG, $cacheArray, $DATA, $DEPTH;
	//* DEBUG: */ echo __LINE__."*".$wht."/".$GLOBALS['module']."/".$GLOBALS['action']."/".$GLOBALS['what']."*<br />\n";
	if (EXT_IS_ACTIVE("cache"))
	{
		// Include cache instance
		global $cacheInstance;
	}

	// Remove any spaces from variable
	if (empty($wht))
	{
		// Default admin action is the overview page
		$wht = "overview";
	}
	 else
	{
		// Compile out some chars
		$wht = COMPILE_CODE($wht, false, false, false);
	}

	// Get action value
	$act = GET_ACTION($GLOBALS['module'], $wht);

	// Define admin login name and ID number
	define('__ADMIN_LOGIN', get_session('admin_login'));
	define('__ADMIN_ID'   , GET_ADMIN_ID(get_session('admin_login')));

	// Preload templates
	if (EXT_IS_ACTIVE("admins")) {
		define('__ADMIN_WELCOME', LOAD_TEMPLATE("admin_welcome_admins", true));
	} else {
		define('__ADMIN_WELCOME', LOAD_TEMPLATE("admin_welcome", true));
	}
	define('__ADMIN_FOOTER' , LOAD_TEMPLATE("admin_footer" , true));
	define('__ADMIN_MENU'   , ADD_ADMIN_MENU($act, $wht, true));

	// Tableset header
	LOAD_TEMPLATE("admin_main_header");

	// Check if action/what pair is valid
	$result = SQL_QUERY_ESC("SELECT id FROM "._MYSQL_PREFIX."_admin_menu
WHERE action='%s' AND ((what='%s' AND what != 'overview') OR ((what='' OR what IS NULL) AND '%s'='overview'))
LIMIT 1", array($act, $wht, $wht), __FILE__, __LINE__);
	if (SQL_NUMROWS($result) == 1)
	{
		// Free memory
		SQL_FREERESULT($result);

		// Is valid but does the inlcude file exists?
		$INC = sprintf("%sinc/modules/admin/action-%s.php", PATH, $act);
		if ((FILE_READABLE($INC)) && (VALIDATE_MENU_ACTION("admin", $act, $wht)) && (__ACL_ALLOW == true))
		{
			// Ok, we finally load the admin action module
			include($INC);
		}
		 elseif (__ACL_ALLOW == false)
		{
			// Access denied
			LOAD_TEMPLATE("admin_menu_failed", false, ADMINS_ACCESS_DENIED);
			ADD_FATAL(ADMINS_ACCESS_DENIED);
		}
		 else
		{
			// Include file not found! :-(
			LOAD_TEMPLATE("admin_menu_failed", false, ADMIN_404_ACTION);
			ADD_FATAL(ADMIN_404_ACTION_1.$act.ADMIN_404_ACTION_2);
		}
	} else {
		// Invalid action/what pair found!
		LOAD_TEMPLATE("admin_menu_failed", false, ADMIN_INVALID_ACTION);
		ADD_FATAL(ADMIN_INVALID_ACTION_1.$act."/".$wht.ADMIN_INVALID_ACTION_2);
	}

	// Tableset footer
	LOAD_TEMPLATE("admin_main_footer");
}
//
function ADD_ADMIN_MENU($act, $wht, $return=false) {
	global $menuDesription, $menuTitle, $cacheInstance, $_CONFIG;

	// Init variables
	$SUB = false;
	$OUT = "";

	// Menu descriptions
	$menuDesription = array();
	$menuTitle = array();

	// Is there a cache instance?
	if ((is_object($cacheInstance)) && (isset($_CONFIG['cache_admin_menu'])) && ($_CONFIG['cache_admin_menu'] == "Y")) {
		// Create cache name
		$cacheName = "admin_".$act."_".$wht."_".GET_LANGUAGE()."_".strtolower(get_session('admin_login'));

		// Is that cache there?
		if ($cacheInstance->cache_file($cacheName, true)) {
			// Then load it
			$data = $cacheInstance->cache_load();

			// Extract all parts
			$OUT = base64_decode($data['output'][0]);
			$menuTitle = unserialize(base64_decode($data['title'][0]));
			$menuDescription = unserialize(base64_decode($data['descr'][0]));

			// Return or output content?
			if ($return) {
				return $OUT;
			} else {
				OUTPUT_HTML($OUT);
			}
		} // END - if
	} // END - if

	// Build main menu
	$result_main = SQL_QUERY("SELECT action, title, descr FROM "._MYSQL_PREFIX."_admin_menu WHERE (what='' OR what IS NULL) ORDER BY sort, id DESC", __FILE__, __LINE__);
	if (SQL_NUMROWS($result_main) > 0)
	{
		$OUT = "<TABLE border=\"0\" cellspacing=\"0\" cellpadding=\"0\" class=\"admin_menu_main\">
<TR><TD colspan=\"2\" height=\"7\" class=\"seperator\">&nbsp;</TD></TR>\n";
		while (list($menu, $title, $descr) = SQL_FETCHROW($result_main))
		{
			if ((EXT_IS_ACTIVE("admins")) && (GET_EXT_VERSION("admins") > "0.2"))
			{
				$ACL = ADMINS_CHECK_ACL($menu, "");
			}
			 else
			{
				// ACL is "allow"... hmmm
				$ACL = true;
			}
			if ($ACL)
			{
				if (!$SUB)
				{
					// Insert compiled menu title and description
					$menuTitle[$menu]      = $title;
					$menuDesription[$menu] = $descr;
				}
				$OUT .= "<TR>
	<TD class=\"admin_menu\" colspan=\"2\">
		<NOBR>&nbsp;<STRONG>&middot;</STRONG>&nbsp;";
				if (($menu == $act) && (empty($wht)))
				{
					$OUT .= "<STRONG>";
				}
				 else
				{
					$OUT .= "[<A href=\"".URL."/modules.php?module=admin&amp;action=".$menu."\">";
				}
				$OUT .= $title;
				if (($menu == $act) && (empty($wht)))
				{
					$OUT .= "</STRONG>";
				}
				 else
				{
					$OUT .= "</A>]";
				}
				$OUT .= "</NOBR></TD>
</TR>\n";
				$result_what = SQL_QUERY_ESC("SELECT what, title, descr FROM "._MYSQL_PREFIX."_admin_menu WHERE action='%s' AND what != '' AND what IS NOT NULL ORDER BY sort, id DESC",
				 array($menu), __FILE__, __LINE__);
				if ((SQL_NUMROWS($result_what) > 0) && ($act == $menu))
				{
					$menuDesription = array();
					$menuTitle = array(); $SUB = true;
					$OUT .= "<TR>
	<TD width=\"10\" class=\"seperator\">&nbsp;</TD>
	<TD class=\"admin_menu\">
		<TABLE border=\"0\" cellspacing=\"0\" cellpadding=\"0\" class=\"admin_menu_sub\">\n";
					while (list($wht_sub, $title_what, $desc_what) = SQL_FETCHROW($result_what)) {
						// Filename
						$INC = sprintf("%sinc/modules/admin/what-%s.php", PATH, $wht_sub);
						if ((EXT_IS_ACTIVE("admins")) && (GET_EXT_VERSION("admins") > "0.2")) {
							$ACL = ADMINS_CHECK_ACL("", $wht_sub);
						} else {
							// ACL is "allow"... hmmm
							$ACL = true;
						}
						$readable = FILE_READABLE($INC);
						if ($ACL) {
							// Insert compiled title and description
							$menuTitle[$wht_sub]      = $title_what;
							$menuDesription[$wht_sub] = $desc_what;
							$OUT .= "<TR>
	<TD class=\"admin_menu\" colspan=\"2\">
		<NOBR>&nbsp;<STRONG>--&gt;</STRONG>&nbsp;";
							if ($readable)
							{
								if ($wht == $wht_sub)
								{
									$OUT .= "<STRONG>";
								}
								 else
								{
									$OUT .= "[<A href=\"".URL."/modules.php?module=admin&amp;what=".$wht_sub."\">";
								}
							}
							 else
							{
								$OUT .= "<I class=\"admin_note\">";
							}
							$OUT .= $title_what;
							if ($readable)
							{
								if ($wht == $wht_sub)
								{
									$OUT .= "</STRONG>";
								}
								 else
								{
									$OUT .= "</A>]";
								}
							}
							 else
							{
								$OUT .= "</I>";
							}
							$OUT .= "</NOBR></TD>
</TR>\n";
						}
					}

					// Free memory
					SQL_FREERESULT($result_what);
					$OUT .= "    </TABLE>
	</TD>
</TR>\n";
				}
				$OUT .= "<TR><TD height=\"7\" colspan=\"2\"></TD></TR>\n";
			}
		}

		// Free memory
		SQL_FREERESULT($result_main);
		$OUT .= "</TABLE>\n";
	}

	// Compile and run the code here. This inserts all constants into the
	// HTML output. Costs me some time to figure this out... *sigh* Quix0r
	$eval = "\$OUT = \"".COMPILE_CODE(addslashes($OUT))."\";";
	eval($eval);

	// Is there a cache instance again?
	if ((is_object($cacheInstance)) && (isset($_CONFIG['cache_admin_menu'])) && ($_CONFIG['cache_admin_menu'] == "Y")) {
		// Init cache
		$cacheInstance->cache_init($cacheName);

		// Prepare cache data
		$data = array(
			'output' => base64_encode($OUT),
			'title'  => $menuTitle,
			'descr'  => $menuDesription
		);

		// Write the data away
		$cacheInstance->add_row($data);

		// Close cache
		$cacheInstance->cache_close();
	} // END - if

	// Return or output content?
	if ($return) {
		return $OUT;
	} else {
		OUTPUT_HTML($OUT);
	}
}
//
function ADD_MEMBER_SELECTION_BOX ($def="0", $add_all=false, $return=false, $none=false, $field="userid")
{
	// Output selection form with all confirmed user accounts listed
	$result = SQL_QUERY("SELECT userid, surname, family FROM "._MYSQL_PREFIX."_user_data ORDER BY userid", __FILE__, __LINE__);
	$OUT = "";

	// USe this only for adding points (e.g. adding refs really makes no sence ;-) )
	if ($add_all) $OUT = "      <OPTION value=\"all\">".ALL_MEMBERS."</OPTION>\n";
	 elseif ($none) $OUT = "      <OPTION value=\"0\">".SELECT_NONE."</OPTION>\n";
	while (list($id, $sname, $fname) = SQL_FETCHROW($result))
	{
		$OUT .= "      <OPTION value=\"".bigintval($id)."\"";
		if ($def == $id) $OUT .= " selected=\"selected\"";
		$OUT .= ">".$sname." ".$fname." (".bigintval($id).")</OPTION>\n";
	}

	// Free memory
	SQL_FREERESULT($result);

	if (!$return) {
		// Remeber options in constant
		define('_MEMBER_SELECTION', $OUT);

		// Display selection box
		define('__LANG_VALUE', GET_LANGUAGE());

		// Load template
		LOAD_TEMPLATE("admin_member_selection_box", false, $GLOBALS['what']);
	} else {
		// Return content in selection frame
		return "<select class=\"admin_select\" name=\"".$field."\" size=\"1\">\n".$OUT."</select>\n";
	}
}
//
function ADMIN_MENU_SELECTION($MODE, $default="", $defid="") {
	$wht = "what != ''";
	if ($MODE == "action") $wht = "(what='' OR what IS NULL) AND action !='login'";
	$result = SQL_QUERY_ESC("SELECT %s, title FROM "._MYSQL_PREFIX."_admin_menu WHERE ".$wht." ORDER BY sort",
	 array($MODE), __FILE__, __LINE__);
	if (SQL_NUMROWS($result) > 0) {
		// Load menu as selection
		$OUT = "<SELECT name=\"".$MODE."_menu";
		if ((!empty($defid)) || ($defid == "0")) $OUT .= "[".$defid."]";
		$OUT .= "\" size=\"1\" class=\"admin_select\">
	<OPTION value=\"\">".SELECT_NONE."</OPTION>\n";
		while (list($menu, $title) = SQL_FETCHROW($result)) {
			$OUT .= "  <OPTION value=\"".$menu."\"";
			if ((!empty($default)) && ($default == $menu)) $OUT .= " selected=\"selected\"";
			$OUT .= ">".$title."</OPTION>\n";
		} // END - while

		// Free memory
		SQL_FREERESULT($result);
		$OUT .= "</SELECT>\n";
	} else {
		// No menus???
		$OUT = ADMIN_PROBLEM_NO_MENU;
	}

	// Return output
	return $OUT;
}
// Save settings to the database
function ADMIN_SAVE_SETTINGS (&$POST, $tableName="_config", $whereStatement="config=0", $translateComma=array(), $alwaysAdd=false) {
	global $_CONFIG, $cacheArray, $cacheInstance;

	// Prepare all arrays, variables
	$DATA = array();
	$skip = false;

	// Now, walk through all entries and prepare them for saving
	foreach ($POST as $id => $val) {
		// Process only formular field but not submit buttons ;)
		if ($id != "ok") {
			// Do not save the ok value
			CONVERT_SELECTIONS_TO_TIMESTAMP($POST, $DATA, $id, $skip);

			// Shall we process this ID? It muss not be empty, of course
			if ((!$skip) && (!empty($id))) {
				// Save this entry
				$val = COMPILE_CODE($val);

				// Translate the value? (comma to dot!)
				if ((is_array($translateComma)) && (in_array($id, $translateComma))) {
					// Then do it here... :)
					$val = str_replace(",", ".", $val);
				} // END - if

				// Shall we add numbers or strings?
				$test = (float)$val;
				if ("".$val."" == "".$test."") {
					// Add numbers
					$DATA[] = $id."=".$val."";
				} else {
					// Add strings
					$DATA[] = $id."='".trim($val)."'";
				}

				// Update current configuration
				$_CONFIG[$id] = $val;
			} // END - if
		} // END - if
	} // END - foreach

	// Check if entry does exist
	$result = false;
	if (!$alwaysAdd) {
		if (!empty($whereStatement)) {
			$result = SQL_QUERY("SELECT * FROM "._MYSQL_PREFIX.$tableName." WHERE ".$whereStatement." LIMIT 1", __FILE__, __LINE__);
		} else {
			$result = SQL_QUERY("SELECT * FROM "._MYSQL_PREFIX.$tableName." LIMIT 1", __FILE__, __LINE__);
		}
	} // END - if

	if (SQL_NUMROWS($result) == 1) {
		// "Implode" all data to single string
		$DATA_UPDATE = implode(", ", $DATA);

		// Generate SQL string
		$SQL = "UPDATE "._MYSQL_PREFIX.$tableName." SET ".$DATA_UPDATE." WHERE ".$whereStatement." LIMIT 1";
	} else {
		// Add Line (does only work with auto_increment!
		$KEYs = array(); $VALUEs = array();
		foreach ($DATA as $entry) {
			// Split up
			$line = explode("=", $entry);
			$KEYs[] = $line[0]; $VALUEs[] = $line[1];
		} // END - foreach

		// Add both in one line
		$KEYs = implode(", ", $KEYs);
		$VALUEs = implode(", ", $VALUEs);

		// Generate SQL string
		$SQL = "INSERT INTO "._MYSQL_PREFIX.$tableName." (".$KEYs.") VALUES(".$VALUEs.")";
	}

	// Free memory
	SQL_FREERESULT($result);

	// Simply run generated SQL string
	$result = SQL_QUERY($SQL, __FILE__, __LINE__);

	// Rebuild cache
	REBUILD_CACHE("config", "config");

	// Settings saved
	LOAD_TEMPLATE("admin_settings_saved", false, "<STRONG class=\"admin_done\">".SETTINGS_SAVED."</STRONG>");
}
//
function ADMIN_MAKE_MENU_SELECTION($menu, $type, $name, $default="") {
	// Open the requested menu directory
	$handle = opendir(sprintf("%sinc/modules/%s/", PATH, $menu)) or mxchange_die("Cannot load menu ".$menu."!");

	// Init the selection box
	$OUT = "<SELECT name=\"".$name."\" class=\"admin_select\" size=\"1\">\n	<OPTION value=\"\">".IS_TOP_MENU."</OPTION>\n";

	// Walk through all files
	while ($file = readdir($handle)) {
		// Is this a PHP script?
		if (($file != ".") && ($file != "..") && ($file != "lost+found") && (strpos($file, "".$type."-") > -1) && (strpos($file, ".php") > 0)) {
			// Then test if the file is readable
			$test = sprintf("%sinc/modules/%s/%s", PATH, $menu, $file);
			if ((is_file($test)) && (is_readable($test))) {
				// Extract the value for what=xxx
				$part = substr($file, (strlen($type) + 1));
				$part = substr($part, 0, -4);

				// Is that part different from the overview?
				if ($part != "overview") {
					$OUT .= "	<OPTION value=\"".$part."\"";
					if ($part == $default) $OUT .= "selected";
					$OUT .= ">".$part."</OPTION>\n";
				} // END - if
			} // END - if
		} // END - if
	} // END - while

	// Close dir and selection box
	closedir($handle);
	$OUT .= "</SELECT>\n";
	return $OUT;
}
//
function ADMIN_USER_PROFILE_LINK($uid, $title="", $wht="list_user") {
	if (($title == "") && ($title != "0")) {
		// Set userid as title
		$title = $uid;
	} // END - if

	if (($title == "0") && ($wht == "list_refs")) {
		// Return title again
		return $title;
	} // END - if

	//* DEBUG: */ echo "A:".$title."<br />";
	// Return link
	return "<A href=\"".URL."/modules.php?module=admin&amp;what=".$wht."&amp;u_id=".$uid."\" title=\"".ADMIN_USER_PROFILE_TITLE."\">".$title."</A>";
}
//
function ADMIN_CHECK_MENU_MODE() {
	global $_CONFIG, $cacheArray;

	// Set the global mode as the mode for all admins
	$MODE = $_CONFIG['admin_menu']; $ADMIN = $MODE;

	// Check individual settings of current admin
	if (isset($cacheArray['admins']['la_mode'][get_session('admin_login')])) {
		// Load from cache
		$ADMIN = $cacheArray['admins']['la_mode'][get_session('admin_login')];
		$_CONFIG['cache_hits']++;
	} elseif (GET_EXT_VERSION("admins") >= "0.6.7") {
		// Load from database when version of "admins" is enough
		$result = SQL_QUERY_ESC("SELECT la_mode FROM "._MYSQL_PREFIX."_admins WHERE login='%s' LIMIT 1",
		 array(get_session('admin_login')), __FILE__, __LINE__);
		if (SQL_NUMROWS($result) == 1) {
			// Load data
			list($ADMIN) = SQL_FETCHROW($result);
		}

		// Free memory
		SQL_FREERESULT($result);
	}

	// Check what the admin wants and set it when it's not the global mode
	if ($ADMIN != "global") $MODE = $ADMIN;

	// Return admin-menu's mode
	return $MODE;
}
// Change activation status
function ADMIN_CHANGE_ACTIVATION_STATUS ($IDs, $table, $row, $idRow = "id") {
	global $_CONFIG;
	$cnt = 0; $newStatus = "Y";
	if ((is_array($IDs)) && (count($IDs) > 0)) {
		// "Walk" all through and count them
		foreach ($IDs as $id => $selected) {
			// Secure the ID number
			$id = bigintval($id);

			// Should always be 1 ;-)
			if ($selected == 1) {
				// Determine new status
				$result = SQL_QUERY_ESC("SELECT %s FROM "._MYSQL_PREFIX."_%s WHERE %s=%s LIMIT 1",
					array($row, $table, $idRow, $id), __FILE__, __LINE__);

				// Row found?
				if (SQL_NUMROWS($result) == 1) {
					// Load the status
					list($currStatus) = SQL_FETCHROW($result);
					if ($currStatus == "Y") $newStatus='N'; else $newStatus = "Y";

					// Change this status
					SQL_QUERY_ESC("UPDATE "._MYSQL_PREFIX."_%s SET %s='%s' WHERE %s=%s LIMIT 1",
						array($table, $row, $newStatus, $idRow, $id), __FILE__, __LINE__);

					// Count up affected rows
					$cnt += SQL_AFFECTEDROWS();
				}

				// Free the result
				SQL_FREERESULT($result);
			}
		}

		// Output status
		LOAD_TEMPLATE("admin_settings_saved", false, ADMIN_STATUS_CHANGED_1.$cnt.ADMIN_STATUS_CHANGED_2.count($IDs).ADMIN_STATUS_CHANGED_3);
	} else {
		// Nothing selected!
		LOAD_TEMPLATE("admin_settings_saved", false, ADMIN_NOTHING_SELECTED_CHANGE);
	}
}
// Send mails for del/edit/lock build modes
function ADMIN_SEND_BUILD_MAILS ($mode, $table, $content, $id, $subjectPart="") {
	// Default subject is the subject part
	$subject = $subjectPart;

	// Is the subject part not set?
	if (empty($subjectPart)) {
		// Then use it from the mode
		$subject = strtoupper($mode);
	} // END - if

	// Is the raw userid set?
	if ($_POST['uid_raw'][$id] > 0) {
		// Generate subject
		$eval = "\$subjectLine = MEMBER_".$subject."_".strtoupper($table)."_SUBJECT;";
		eval($eval);

		// Load email template
		if (!empty($subjectPart)) {
			$mail = LOAD_EMAIL_TEMPLATE("member_".$mode."_".strtolower($subjectPart)."_".$table, $content);
		} else {
			$mail = LOAD_EMAIL_TEMPLATE("member_".$mode."_".$table, $content);
		}

		// Send email out
		SEND_EMAIL($_POST['uid_raw'][$id], $subjectLine, $mail);
	} // END - if

	// Generate subject
	$eval = "\$subjectLine = ADMIN_".$subject."_".strtoupper($table)."_SUBJECT;";
	eval($eval);

	// Send admin notification out
	if (!empty($subjectPart)) {
		SEND_ADMIN_NOTIFICATION($subjectLine, "admin_".$mode."_".strtolower($subjectPart)."_".$table, $content, $_POST['uid_raw'][$id]);
	} else {
		SEND_ADMIN_NOTIFICATION($subjectLine, "admin_".$mode."_".$table, $content, $_POST['uid_raw'][$id]);
	}
}
// Build a special template list
function ADMIN_BUILD_LIST ($listType, $IDs, $table, $columns, $filterFunctions, $extraValues, $idColumn, $userIdColumn) {
	global $_CONFIG;
	$OUT = ""; $SW = 2;

	// "Walk" through all entries
	foreach ($IDs as $id => $selected) {
		// Secure ID number
		$id = bigintval($id);

		// Get result from a given column array and table name
		$result = SQL_RESULT_FROM_ARRAY($table, $columns, $idColumn, $id, __FILE__, __LINE__);

		// Is there one entry?
		if (SQL_NUMROWS($result) == 1) {
			// Load all data
			$content = SQL_FETCHARRAY($result);

			// Filter all data
			foreach ($content as $key => $value) {
				// Search index
				$idx = array_search($key, $columns, true);

				// Do we have a userid?
				if ($key == "userid") {
					// Add it again as raw id
					$content['uid'] = bigintval($value);
				} // END - if

				// Handle the call in external function
				$content[$key] = HANDLE_EXTRA_VALUES($filterFunctions[$idx], $value, $extraValues[$idx]);
			} // END - foreach

			// Add color switching
			$content['sw'] = $SW;

			// Then list it
			$OUT .= LOAD_TEMPLATE("admin_".$listType."_".$table."_row", true, $content);

			// Switch color
			$SW = 3 - $SW;
		} // END - if

		// Free the result
		SQL_FREERESULT($result);
	} // END - foreach

	// Load master template
	LOAD_TEMPLATE("admin_".$listType."_".$table."", false, $OUT);
}
// Change status of "build" list
function ADMIN_BUILD_STATUS_HANDLER ($mode, $IDs, $table, $columns, $filterFunctions, $extraValues, $idColumn, $userIdColumn, $statusArray) {
	// All valid entries? (We hope so here!)
	if ((is_array($IDs)) && (count($IDs) > 0) && (count($columns) == count($filterFunctions)) && (count($columns) == count($extraValues)) && (count($statusArray) > 0)) {
		// "Walk" through all entries
		foreach ($IDs as $id => $sel) {
			// Construct SQL query
			$SQL = "UPDATE "._MYSQL_PREFIX."_".$table." SET";

			// Load data of entry
			$result = SQL_QUERY_ESC("SELECT * FROM "._MYSQL_PREFIX."_%s WHERE %s=%s LIMIT 1",
				array($table, $idColumn, $id), __FILE__, __LINE__);

			// Fetch the data
			$content = SQL_FETCHARRAY($result);

			// Free the result
			SQL_FREERESULT($result);

			// Add all status entries (e.g. status column last_updated or so)
			$newStatus = "UNKNOWN";
			$oldStatus = "UNKNOWN";
			$statusColumn = "unknown";
			foreach ($statusArray as $column => $statusInfo) {
				// Does the entry exist?
				if ((isset($content[$column])) && (isset($statusInfo[$content[$column]]))) {
					// Add these entries for update
					$SQL .= sprintf(" %s='%s',", SQL_ESCAPE($column), SQL_ESCAPE($statusInfo[$content[$column]]));

					// Remember status
					if ($statusColumn == "unknown") {
						// Always (!!!) change status column first!
						$oldStatus = $content[$column];
						$newStatus = $statusInfo[$oldStatus];
						$statusColumn = $column;
					} // END - if
				} elseif (isset($content[$column])) {
					// Unfinished!
					mxchange_die("{--".__FUNCTION__."--}:UNFINISHED: id={$id}/{$column}[".gettype($statusInfo)."] = {$content[$column]}");
				}
			} // END - foreach

			// Add other columns as well
			foreach ($_POST as $key => $entries) {
				// Skip id, raw userid and 'do_lock'
				if (!in_array($key, array($idColumn, 'uid_raw', 'do_lock'))) {
					// Are there brackets () at the end?
					if (substr($entries[$id], -2, 2) == "()") {
						// Direct SQL command found
						$SQL .= sprintf(" %s=%s,", SQL_ESCAPE($key), SQL_ESCAPE($entries[$id]));
					} else {
						// Add regular entry
						$SQL .= sprintf(" %s='%s',", SQL_ESCAPE($key), SQL_ESCAPE($entries[$id]));
					}
				} // END - if
			} // END - if

			// Finish SQL statement
			$SQL = substr($SQL, 0, -1) . " WHERE ".$idColumn."=".bigintval($id)." AND ".$statusColumn."='".$oldStatus."' LIMIT 1";

			// Run the SQL
			SQL_QUERY($SQL, __FILE__, __LINE__);

			// Do we have an URL?
			if (isset($content['url'])) {
				// Then add a framekiller test as well
				$content['frametester'] = FRAMETESTER($content['url']);
			} // END - if

			// Send "build mails" out
			ADMIN_SEND_BUILD_MAILS($mode, $table, $content, $id, $statusInfo[$content[$column]]);
		} // END - foreach
	} // END - if
}
// Delete rows by given ID numbers
function ADMIN_DELETE_ENTRIES_CONFIRM ($IDs, $table, $columns=array(), $filterFunctions=array(), $extraValues=array(), $deleteNow=false, $idColumn="id", $userIdColumn="userid") {
	// All valid entries? (We hope so here!)
	if ((is_array($IDs)) && (count($IDs) > 0) && (count($columns) == count($filterFunctions)) && (count($columns) == count($extraValues))) {
		// Shall we delete here or list for deletion?
		if ($deleteNow) {
			// The base SQL command:
			$SQL = "DELETE LOW_PRIORITY FROM "._MYSQL_PREFIX."_%s WHERE %s IN (%s)";

			// Delete them all
			$idList = "";
			foreach ($IDs as $id => $sel) {
				// Is there a userid?
				if (isset($_POST['uid_raw'][$id])) {
					// Load all data from that id
					$result = SQL_QUERY_ESC("SELECT * FROM "._MYSQL_PREFIX."_%s WHERE %s=%s LIMIT 1",
						array($table, $idColumn, $id), __FILE__, __LINE__);

					// Fetch the data
					$content = SQL_FETCHARRAY($result);

					// Free the result
					SQL_FREERESULT($result);

					// Send "build mails" out
					ADMIN_SEND_BUILD_MAILS("del", $table, $content, $id);
				} // END - if

				// Add id number
				$idList .= $id.",";
			} // END - foreach

			// Run the query
			SQL_QUERY($SQL, array($table, $idColumn, substr($idList, 0, -1)), __FILE__, __LINE__);

			// Was this fine?
			if (SQL_AFFECTEDROWS() == count($IDs)) {
				// All deleted
				LOAD_TEMPLATE("admin_settings_saved", false, ADMIN_ALL_ENTRIES_REMOVED);
			} else {
				// Some are still there :(
				LOAD_TEMPLATE("admin_settings_saved", false, sprintf(ADMIN_SOME_ENTRIES_NOT_DELETED, SQL_AFFECTEDROWS(), count($IDs)));
			}
		} else {
			// List for deletion confirmation
			ADMIN_BUILD_LIST("del", $IDs, $table, $columns, $filterFunctions, $extraValues, $idColumn, $userIdColumn);
		}
	} // END - if
}
// Edit rows by given ID numbers
function ADMIN_EDIT_ENTRIES_CONFIRM ($IDs, $table, $columns=array(), $filterFunctions=array(), $extraValues=array(), $editNow=false, $idColumn="id", $userIdColumn="userid") {
	// All valid entries? (We hope so here!)
	if ((is_array($IDs)) && (count($IDs) > 0) && (count($columns) == count($filterFunctions)) && (count($columns) == count($extraValues))) {
		// Shall we change here or list for editing?
		if ($editNow) {
			// Change them all
			$affected = 0;
			foreach ($IDs as $id => $sel) {
				// Prepare content array (new values)
				$content = array();

				// Prepare SQL for this row
				$SQL = "UPDATE "._MYSQL_PREFIX."_".$table." SET";
				foreach ($_POST as $key => $entries) {
					// Skip raw userid which is always invalid
					if ($key == "uid_raw") {
						// Continue with next field
						continue;
					} // END - if

					// Is entries an array?
					if (($key != $idColumn) && (is_array($entries)) && (isset($entries[$id]))) {
						// Add this entry to content
						$content[$key] = $entries[$id];

						// Send data through the filter function if found
						if ((isset($filterFunctions[$key])) && (isset($extraValues[$key]))) {
							// Filter function set!
							$entries[$id] = HANDLE_EXTRA_VALUES($filterFunctions[$key], $entries[$id], $extraValues[$key]);
						} // END - if

						// Then add this value
						$SQL .= sprintf(" %s='%s',",
							SQL_ESCAPE($key),
							SQL_ESCAPE($entries[$id])
						);
					} elseif (($key != $idColumn) && (!is_array($entries))) {
						// Add normal entries as well!
						$content[$key] =  $entries;
					}

					// Do we have an URL?
					if ($key == "url") {
						// Then add a framekiller test as well
						$content['frametester'] = FRAMETESTER($content[$key]);
					} // END - if
				} // END - foreach

				// Finish SQL command
				$SQL = substr($SQL, 0, -1) . " WHERE ".$idColumn."=".bigintval($id)." LIMIT 1";

				// Run this query
				SQL_QUERY($SQL, __FILE__, __LINE__);

				// Add affected rows
				$affected += SQL_AFFECTEDROWS();

				// Load all data from that id
				$result = SQL_QUERY_ESC("SELECT * FROM "._MYSQL_PREFIX."_%s WHERE %s=%s LIMIT 1",
					array($table, $idColumn, $id), __FILE__, __LINE__);

				// Fetch the data
				global $DATA;
				$DATA = SQL_FETCHARRAY($result);

				// Free the result
				SQL_FREERESULT($result);

				// Send "build mails" out
				ADMIN_SEND_BUILD_MAILS("edit", $table, $content, $id);
			} // END - foreach

			// Was this fine?
			if ($affected == count($IDs)) {
				// All deleted
				LOAD_TEMPLATE("admin_settings_saved", false, ADMIN_ALL_ENTRIES_EDITED);
			} else {
				// Some are still there :(
				LOAD_TEMPLATE("admin_settings_saved", false, sprintf(ADMIN_SOME_ENTRIES_NOT_EDITED, $affected, count($IDs)));
			}
		} else {
			// List for editing
			ADMIN_BUILD_LIST("edit", $IDs, $table, $columns, $filterFunctions, $extraValues, $idColumn, $userIdColumn);
		}
	} // END - if
}
// Un-/lock rows by given ID numbers
function ADMIN_LOCK_ENTRIES_CONFIRM ($IDs, $table, $columns=array(), $filterFunctions=array(), $extraValues=array(), $statusArray=array(), $lockNow=false, $idColumn="id", $userIdColumn="userid") {
	// All valid entries? (We hope so here!)
	if ((is_array($IDs)) && (count($IDs) > 0) && (count($columns) == count($filterFunctions)) && (count($columns) == count($extraValues)) && ((!$lockNow) || (count($statusArray) == 1))) {
		// Shall we un-/lock here or list for locking?
		if ($lockNow) {
			// Un-/lock entries
			ADMIN_BUILD_STATUS_HANDLER("lock", $IDs, $table, $columns, $filterFunctions, $extraValues, $idColumn, $userIdColumn);
		} else {
			// List for editing
			ADMIN_BUILD_LIST("lock", $IDs, $table, $columns, $filterFunctions, $extraValues, $idColumn, $userIdColumn);
		}
	} // END - if
}
// Undelete rows by given ID numbers
function ADMIN_UNDELETE_ENTRIES_CONFIRM ($IDs, $table, $columns=array(), $filterFunctions=array(), $extraValues=array(), $statusArray=array(), $lockNow=false, $idColumn="id", $userIdColumn="userid") {
	// All valid entries? (We hope so here!)
	if ((is_array($IDs)) && (count($IDs) > 0) && (count($columns) == count($filterFunctions)) && (count($columns) == count($extraValues)) && ((!$lockNow) || (count($statusArray) == 1))) {
		// Shall we un-/lock here or list for locking?
		if ($lockNow) {
			// Undelete entries
			ADMIN_BUILD_STATUS_HANDLER("undelete", $IDs, $table, $columns, $filterFunctions, $extraValues, $idColumn, $userIdColumn, $statusArray);
		} else {
			// List for editing
			ADMIN_BUILD_LIST("undelete", $IDs, $table, $columns, $filterFunctions, $extraValues, $idColumn, $userIdColumn);
		}
	} // END - if
}
// Checks proxy settins by fetching check-updates3.php from www.mxchange.org
function ADMIN_TEST_PROXY_SETTINGS ($settingsArray) {
	global $_CONFIG;

	// Set temporary the new settings
	$_CONFIG = array_merge($_CONFIG, $settingsArray);

	// Now get the test URL
	$content = GET_URL("check-updates3.php");

	// Is the first line with "200 OK"?
	$valid = eregi("200 OK", $content[0]);

	// Return result
	return $valid;
}
// Sends out a link to the given email adress so the admin can reset his/her password
function ADMIN_SEND_PASSWORD_RESET_LINK ($email) {
	global $_CONFIG;
	// Init output
	$OUT = "";

	// Compile out security characters (must be for looking up!)
	$email = COMPILE_CODE($email);

	// Look up administator login
	$result = SQL_QUERY_ESC("SELECT id, login, password FROM "._MYSQL_PREFIX."_admins WHERE email='%s' LIMIT 1",
		array($email), __FILE__, __LINE__);

	// Is there an account?
	if (SQL_NUMROWS($result) == 0) {
		// No account found!
		return ADMIN_NO_LOGIN_WITH_EMAIL;
	} // END - if

	// Load all data
	$content = SQL_FETCHARRAY($result);

	// Free result
	SQL_FREERESULT($result);

	// Generate hash for reset link
	$content['hash'] = generateHash(URL.":".$content['id'].":".$content['login'].":".$content['password'], substr($content['password'], 10));

	// Remove some data
	unset($content['id']);
	unset($content['password']);

	// Prepare email
	$mailText = LOAD_EMAIL_TEMPLATE("admin_reset_password", $content);

	// Send it out
	SEND_EMAIL($email, ADMIN_RESET_PASS_LINK_SUBJ, $mailText);

	// Prepare output
	return ADMIN_RESET_LINK_SENT;
}
// Validate hash and login for password reset
function ADMIN_VALIDATE_RESET_LINK_HASH_LOGIN ($hash, $login) {
	// By default nothing validates... ;)
	$valid = false;

	// Compile the login for lookup
	$login = COMPILE_CODE($login);

	// Then try to find that user
	$result = SQL_QUERY_ESC("SELECT id, password, email FROM "._MYSQL_PREFIX."_admins WHERE login='%s' LIMIT 1",
		array($login), __FILE__, __LINE__);

	// Is an account here?
	if (SQL_NUMROWS($result) == 1) {
		// Load all data
		$content = SQL_FETCHARRAY($result);

		// Generate hash again
		$hashFromData = generateHash(URL.":".$content['id'].":".$login.":".$content['password'], substr($content['password'], 10));

		// Does both match?
		$valid = ($hash == $hashFromData);
	} // END - if

	// Free result
	SQL_FREERESULT($result);

	// Return result
	return $valid;
}
// Reset the password for the login. Do NOT call this function without calling above function first!
function ADMIN_RESET_PASSWORD ($login, $password) {
	// Init hash
	$passHash = "";

	// Now check if we have sql_patches installed
	if (GET_EXT_VERSION("sql_patches") >= "0.3.6") {
		// Use new way of hashing
		$passHash = generateHash($password);
	} else {
		// Old MD5 method
		$passHash = md5($password);
	}

	// Update database
	SQL_QUERY_ESC("UPDATE "._MYSQL_PREFIX."_admins SET password='%s' WHERE login='%s' LIMIT 1",
		array($passHash, $login), __FILE__, __LINE__);

	// Return output
	return ADMIN_PASSWORD_RESET_DONE;
}
// Solves a task by given id number
function ADMIN_SOLVE_TASK ($id) {
	// Update the task data
	ADMIN_UPDATE_TASK_DATA($id, "status", "SOLVED");
}
// Marks a given task as deleted
function ADMIN_DELETE_TASK ($id) {
	// Update the task data
	ADMIN_UPDATE_TASK_DATA($id, "status", "DELETED");
}
// Function to update task data
function ADMIN_UPDATE_TASK_DATA ($id, $row, $data) {
	// Update the task
	SQL_QUERY_ESC("UPDATE "._MYSQL_PREFIX."_task_system SET %s='%s' WHERE id=%s LIMIT 1",
		array($row, $data, bigintval($id)), __FILE__, __LINE__);
}
//
?>
